diff -uNrd ircd-hybrid-7.0/src/listener.c anynet-3.0/src/listener.c
--- ircd-hybrid-7.0/src/listener.c	Thu Jan 30 05:28:45 2003
+++ anynet-3.0/src/listener.c	Mon Feb  2 09:02:21 2004
@@ -51,8 +51,9 @@
 
 static struct Listener* ListenerPollList = NULL;
 
+/* rain - added use_ssl parameter for SSL client support */
 static struct Listener* 
-make_listener(int port, struct irc_inaddr *addr)
+make_listener(int port, struct irc_inaddr *addr, int use_ssl)
 {
   struct Listener* listener =
     (struct Listener*) MyMalloc(sizeof(struct Listener));
@@ -64,6 +65,11 @@
 
   listener->port        = port;
 
+#ifdef SSL_CLIENT_SUPPORT
+  /* rain - is this port an SSL port? */
+  listener->is_ssl      = use_ssl;
+#endif
+
   listener->next = NULL;
   return listener;
 }
@@ -134,7 +140,13 @@
                listener->port,
                IsOperAdmin(source_p) ? listener->name : me.name,
                listener->ref_count,
-               (listener->active)?"active":"disabled");
+               (listener->active) ?
+#ifdef SSL_CLIENT_SUPPORT /* rain - show SSL ports if we have SSL support */
+                 (listener->is_ssl ? "active SSL" : "active")
+#else
+                 "active"
+#endif                 
+                 : "disabled");
   }
 }
 
@@ -239,8 +251,9 @@
   return 1;
 }
 
+/* rain - added use_ssl parameter for SSL client support */
 static struct Listener* 
-find_listener(int port, struct irc_inaddr *addr)
+find_listener(int port, struct irc_inaddr *addr, int use_ssl)
 {
   struct Listener* listener = NULL;
   struct Listener* last_closed = NULL;
@@ -251,7 +264,12 @@
     if ( (port == listener->port) &&
          (!memcmp(&PIN_ADDR(addr),
                  &IN_ADDR(listener->addr),
-                 sizeof(struct irc_inaddr))))
+                 sizeof(struct irc_inaddr)))
+#ifdef SSL_CLIENT_SUPPORT
+         /* rain - match SSL status, too */
+         && listener->is_ssl == use_ssl
+#endif
+       )
     {
       /* Try to return an open listener, otherwise reuse a closed one */
       if (listener->fd == -1)
@@ -270,8 +288,9 @@
  * vhost_ip - if non-null must contain a valid IP address string in
  * the format "255.255.255.255"
  */
+/* rain - added use_ssl parameter for SSL client support */
 void 
-add_listener(int port, const char* vhost_ip)
+add_listener(int port, const char* vhost_ip, int use_ssl)
 {
   struct Listener* listener;
   struct irc_inaddr   vaddr;
@@ -294,14 +313,14 @@
       return;
   }
 
-  if ((listener = find_listener(port, &vaddr)))
+  if ((listener = find_listener(port, &vaddr, use_ssl)))
   {
     if (listener->fd > -1)
       return;
   }
   else
   {
-    listener = make_listener(port, &vaddr);
+    listener = make_listener(port, &vaddr, use_ssl);
     listener->next = ListenerPollList;
     ListenerPollList = listener;
   }
diff -uNrd ircd-hybrid-7.0/src/md5.c anynet-3.0/src/md5.c
--- ircd-hybrid-7.0/src/md5.c	Sun Nov 24 03:27:15 2002
+++ anynet-3.0/src/md5.c	Mon Feb  2 02:41:26 2004
@@ -51,13 +51,17 @@
 	0, 0, 0, 0
 };
 
+#if 0 /* rain - don't do this */
 static	unsigned char *seed_char = (unsigned char *)seed;
+#endif
 static void	id_reseed(char *in, int len);
 static void	md5_block(u_int32_t *in, u_int32_t *out, u_int32_t *x);
 
 
 static	u_int32_t databuf_int[MD5_HASH_SIZE];
+#if 0 /* rain - don't do this */
 static	char *databuf = (char *)databuf_int;
+#endif
 
 static int ork[64] = {
 	0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 
@@ -145,7 +149,8 @@
   fd = open(RPATH, O_RDONLY);
   if (fd > 0)
     {
-      read(fd, databuf, 16);
+      /* rain - read directly into int buffer */
+      read(fd, databuf_int, sizeof(databuf_int));
       close(fd);
       md5_block(databuf_int, seed, seed);    	
     }
@@ -160,7 +165,8 @@
   fd = open(RPATH, O_WRONLY|O_CREAT|O_TRUNC);
   if (fd > 0)
     {
-      write(fd, seed_char, 16);
+      /* rain - read directly into int buffer */
+      write(fd, seed, sizeof(seed));
 /* by default on VMS, files can only be read by their owner */
 #ifndef VMS
       fchmod(fd, 0600);
@@ -330,21 +336,33 @@
 {
   int i;
 
-  for (i=0; i<len; i++)
-    databuf[i%(4*MD5_HASH_SIZE)] += in[i];
+  /* rain - fix the unaligned access here */
+  for (i=0; i<len; i+=4) {
+    databuf_int[i / sizeof(u_int32_t)] += in[i];
+    if (i + 1 < len)
+      databuf_int[i / sizeof(u_int32_t)] += in[i + 1];
+    if (i + 2 < len)
+      databuf_int[i / sizeof(u_int32_t)] += in[i + 2];
+    if (i + 3 < len)
+      databuf_int[i / sizeof(u_int32_t)] += in[i + 3];
+  }
   md5_block(databuf_int, seed, seed);    	
 }
 
 char	*id_get()
 {
   static char id[ID_GEN_LEN+1];
+  unsigned char seed_char; /* rain */
   int i;
 
   md5_block(databuf_int, seed, seed);
 
   id[0] = '.';
-  for (i=1; i<ID_GEN_LEN; i++)
-    id[i] = printable7[seed_char[i] & 127];
+  for (i=1; i<ID_GEN_LEN; i++) {
+    /* rain - fix unaligned accesses */
+    seed_char = seed[i / sizeof(u_int32_t)] << ((i & 3) * 8);
+    id[i] = printable7[seed_char & 127];
+  }
 
   id[ID_GEN_LEN] = '\0';
   return id;
diff -uNrd ircd-hybrid-7.0/src/messages.tab anynet-3.0/src/messages.tab
--- ircd-hybrid-7.0/src/messages.tab	Tue May  6 01:32:17 2003
+++ anynet-3.0/src/messages.tab	Wed Feb  4 12:53:13 2004
@@ -24,7 +24,7 @@
 /* 001  RPL_WELCOME, */ ":%s 001 %s :Welcome to the %s Internet Relay Chat Network %s",
 /* 002  RPL_YOURHOST,*/ ":%s 002 %s :Your host is %s, running version %s",
 /* 003  RPL_CREATED, */ ":%s 003 %s :This server was created %s",
-/* 004  RPL_MYINFO, */ ":%s 004 %s %s %s oiwszcerkfydnxbaugl biklmnopstveIha bkloveIh",
+/* 004  RPL_MYINFO, */ ":%s 004 %s %s %s oiwszcerkfydnxbauglS biklmnopstveIha bkloveIh",
 /* 005  RPL_ISUPPORT, */ ":%s 005 %s %s :are supported by this server",
 /* 006 */       NULL,
 /* 007 */       NULL,
@@ -344,7 +344,7 @@
 /* 317 RPL_WHOISIDLE, */        ":%s 317 %s %s %d %d :seconds idle, signon time",
 /* 318 RPL_ENDOFWHOIS, */       ":%s 318 %s %s :End of /WHOIS list.",
 /* 319 RPL_WHOISCHANNELS, */    ":%s 319 %s %s :%s",
-/* 320 */      NULL,
+/* 320 RPL_WHOISSPECIAL */      ":%s 320 %s %s :%s",
 /* 321 RPL_LISTSTART, */        ":%s 321 %s Channel :Users  Name",
 /* 322 RPL_LIST, */             ":%s 322 %s %s %d :%s",
 /* 323 RPL_LISTEND, */          ":%s 323 %s :End of /LIST",
@@ -503,7 +503,7 @@
 /* 475 ERR_BADCHANNELKEY, */    ":%s 475 %s %s :Cannot join channel (+k)",
 /* 476 ERR_BADCHANMASK, */      ":%s 476 %s %s :Bad Channel Mask",
 /* 477 ERR_MODELESS, */         ":%s 477 %s %s :Channel does not support modes",
-/* 478 ERR_BANLISTFULL, */      ":%s 478 %s %s %s :Channel ban list is full",
+/* 478 ERR_BANLISTFULL, */      ":%s 478 %s %s %s :Channel ban/mask list is full",
 /* 479 ERR_BADCHANNAME */       ":%s 479 %s %s :Illegal channel name",
 /* 480 */       NULL,
 /* 481 ERR_NOPRIVILEGES, */
diff -uNrd ircd-hybrid-7.0/src/modules.c anynet-3.0/src/modules.c
--- ircd-hybrid-7.0/src/modules.c	Tue Jan 21 09:26:51 2003
+++ anynet-3.0/src/modules.c	Mon Feb  2 10:29:43 2004
@@ -572,6 +572,8 @@
 	mod_add_cmd(&drop_msgtab);
 	mod_add_cmd(&eob_msgtab);
 	mod_add_cmd(&gline_msgtab);
+    /* rain - for new GLINE module */
+    hook_add_hook("burst", (hookfn *)gline_netburst);
 	mod_add_cmd(&help_msgtab);
 	mod_add_cmd(&info_msgtab);
 	mod_add_cmd(&invite_msgtab);
@@ -621,7 +623,8 @@
 	mod_add_cmd(&trace_msgtab);
 	mod_add_cmd(&msgtabs[0]);
 	mod_add_cmd(&msgtabs[1]);
-	mod_add_cmd(&msgtabs[2]);
+/* rain - UNGLINE is no more */
+/*	mod_add_cmd(&msgtabs[2]); */
 	mod_add_cmd(&unresv_msgtab);
 	mod_add_cmd(&user_msgtab);
 	mod_add_cmd(&userhost_msgtab);
@@ -631,6 +634,13 @@
 	mod_add_cmd(&who_msgtab);
 	mod_add_cmd(&whois_msgtab);
 	mod_add_cmd(&whowas_msgtab);
+    /* rain - made these modules default */
+    tburst_init();
+	mod_add_cmd(&map_msgtab);
+	/* rain - add STARTTLS module if we have SSL client support */
+#ifdef SSL_CLIENT_SUPPORT
+    mod_add_cmd(&starttls_msgtab);
+#endif
 }
 
 #endif /* STATIC_MODULES */
diff -uNrd ircd-hybrid-7.0/src/packet.c anynet-3.0/src/packet.c
--- ircd-hybrid-7.0/src/packet.c	Sun Feb 16 17:54:37 2003
+++ anynet-3.0/src/packet.c	Mon Feb  2 03:03:15 2004
@@ -378,6 +378,11 @@
 #ifndef NDEBUG
   struct hook_io_data hdata;
 #endif
+
+#ifdef SSL_CLIENT_SUPPORT /* rain - only used for SSL clients */
+readagain:
+#endif
+
   if(IsDefunct(client_p))
     return;
   
@@ -397,7 +402,40 @@
    * I personally think it makes the code too hairy to make sane.
    *     -- adrian
    */
-  length = recv(fd_r, readBuf, READBUF_SIZE, 0);
+#ifdef SSL_CLIENT_SUPPORT
+  /* rain - handle encrypted reads from SSL clients... */
+  if (lclient_p && lclient_p->ssl_state != SSLC_STATE_NONE) {
+    /*
+     * If we're in the handshaking state, do the handshake and fake a
+     * read error (because we don't have any real data to read yet)
+     */
+    if (lclient_p->ssl_state == SSLC_STATE_HANDSHAKE ||
+        lclient_p->ssl_state == SSLC_STATE_STARTTLS) {
+      
+      /*
+       * rain - we'll have an SSL structure after this point, so we
+       * can do the pending check below...  change the state to HANDSHAKE
+       * in case we got here because it was STARTTLS
+       */
+      
+      lclient_p->ssl_state = SSLC_STATE_HANDSHAKE;
+
+      if (SSLC_handshake(client_p) < 0) {
+      	exit_client(client_p, client_p, &me, "Error in SSL/TLS negotiation");
+        return;
+      }
+
+      /*
+       * pretend the read would've blocked so that we get called again
+       * when we have real data (or more handshake data)
+       */
+      length = -1;
+      errno = EWOULDBLOCK;
+    } else if (lclient_p->ssl_state == SSLC_STATE_CONNECTED)
+      length = SSLC_read(client_p, readBuf, READBUF_SIZE);
+  } else
+#endif
+    length = recv(fd_r, readBuf, READBUF_SIZE, 0);
 
   if (length <= 0)
   {
@@ -478,6 +516,20 @@
 		     read_packet, client_p, 0);
     }
   }
+#ifdef SSL_CLIENT_SUPPORT
+  /*
+   * rain - the SSL code may end up buffering some data, so select()
+   * won't get called again -- we re-read if the SSL code says we have
+   * data pending.  Don't do it if our state if STARTTLS because we
+   * won't have an SSL structure yet.
+   */
+  if (lclient_p != NULL && (lclient_p->ssl_state == SSLC_STATE_HANDSHAKE ||
+    lclient_p->ssl_state == SSLC_STATE_CONNECTED)) {
+    
+    if (SSL_pending(lclient_p->ssl))
+      goto readagain;
+  }
+#endif
 }
 
 /*
diff -uNrd ircd-hybrid-7.0/src/parse.c anynet-3.0/src/parse.c
--- ircd-hybrid-7.0/src/parse.c	Mon Jun  9 22:16:54 2003
+++ anynet-3.0/src/parse.c	Sat Jan 31 19:39:31 2004
@@ -378,8 +378,9 @@
 	    return(-1);
 	}
 
+      /* rain - added missing space */
       sendto_realops_flags(FLAGS_ALL, L_ALL, 
-			   "Dropping server %s due to (invalid) command '%s'"
+			   "Dropping server %s due to (invalid) command '%s' "
 			   "with only %d arguments (expecting %d).",
 			   client_p->name, mptr->cmd, i, mptr->parameters);
       ilog(L_CRIT, "Insufficient parameters (%d) for command '%s' from %s.",
diff -uNrd ircd-hybrid-7.0/src/rsa.c anynet-3.0/src/rsa.c
--- ircd-hybrid-7.0/src/rsa.c	Thu May 29 01:13:26 2003
+++ anynet-3.0/src/rsa.c	Fri Jan 23 02:20:17 2004
@@ -138,8 +138,9 @@
     ilog(L_CRIT, "Private key corrupted: pad %i != pad %i",
                  mkey->pad, key->pad);
 
+  /* rain - fix varargs - %d -> %ld */
   if (mkey->version != key->version)
-    ilog(L_CRIT, "Private key corrupted: version %i != version %i",
+    ilog(L_CRIT, "Private key corrupted: version %ld != version %ld",
                   mkey->version, key->version);
 
   if (BN_cmp(mkey->n, key->n))
diff -uNrd ircd-hybrid-7.0/src/s_auth.c anynet-3.0/src/s_auth.c
--- ircd-hybrid-7.0/src/s_auth.c	Thu May 29 01:13:26 2003
+++ anynet-3.0/src/s_auth.c	Mon Feb  2 02:45:45 2004
@@ -87,8 +87,9 @@
   REPORT_HOST_TOOLONG
 } ReportType;
 
+/* rain - don't send to fd directly so that SSL clients can receive these */
 #define sendheader(c, r) \
-   send((c)->localClient->fd, HeaderMessages[(r)].message, HeaderMessages[(r)].length, 0)
+   sendto_one(c, HeaderMessages[(r)].message);
 
 /*
  */
diff -uNrd ircd-hybrid-7.0/src/s_bsd.c anynet-3.0/src/s_bsd.c
--- ircd-hybrid-7.0/src/s_bsd.c	Sat May 31 03:37:05 2003
+++ anynet-3.0/src/s_bsd.c	Mon Feb  2 02:46:13 2004
@@ -319,6 +319,13 @@
     {
       /* attempt to flush any pending dbufs. Evil, but .. -- adrian */
       send_queued_write(client_p->localClient->fd, client_p);
+
+#ifdef SSL_CLIENT_SUPPORT
+      /* rain - shut down the SSL connection if necessary */
+      if (client_p->localClient->ssl_state != SSLC_STATE_NONE)
+        SSLC_shutdown(client_p);
+#endif
+      
       fd_close(client_p->localClient->fd);
       client_p->localClient->fd = -1;
     }
@@ -424,6 +431,12 @@
   
   new_client->localClient->listener  = listener;
   ++listener->ref_count;
+
+#ifdef SSL_CLIENT_SUPPORT
+  /* rain - set up the SSL handshake */
+  if (listener->is_ssl)
+    new_client->localClient->ssl_state = SSLC_STATE_HANDSHAKE;
+#endif
 
   if (!set_non_blocking(new_client->localClient->fd))
     report_error(L_ALL, NONB_ERROR_MSG, get_client_name(new_client, SHOW_IP), errno);
diff -uNrd ircd-hybrid-7.0/src/s_bsd_devpoll.c anynet-3.0/src/s_bsd_devpoll.c
--- ircd-hybrid-7.0/src/s_bsd_devpoll.c	Tue Nov 26 22:46:57 2002
+++ anynet-3.0/src/s_bsd_devpoll.c	Thu Jan 22 12:18:05 2004
@@ -87,8 +87,9 @@
  
 	/* Write the thing to our poll fd */
 	retval = write(dpfd, &pollfds[0], sizeof(struct pollfd));
+    /* rain - removed extraneous \n */
 	if (retval != sizeof(struct pollfd))
-		ilog(L_NOTICE, "devpoll_write_update: dpfd write failed %d: %s\n", errno, strerror(errno));
+		ilog(L_NOTICE, "devpoll_write_update: dpfd write failed %d: %s", errno, strerror(errno));
     /* Done! */
 }
 
@@ -121,7 +122,8 @@
 			break;
 		default:
 #ifdef NOTYET
-		ilog(L_NOTICE,"devpoll_update_events called with unknown filter: %hd\n", filter);
+       /* rain - removed extraneous \n */
+		ilog(L_NOTICE,"devpoll_update_events called with unknown filter: %hd", filter);
 #endif
 		return;
 		break;
@@ -171,7 +173,8 @@
 	dpfd = open("/dev/poll", O_RDWR);
 	if (dpfd < 0) 
 	{
-	ilog(L_CRIT, "init_netio: Couldn't open /dev/poll - %d: %s\n", errno, strerror(errno));
+    /* rain - removed extraneous \n */
+	ilog(L_CRIT, "init_netio: Couldn't open /dev/poll - %d: %s", errno, strerror(errno));
         exit(115); /* Whee! */
     	}
 }
@@ -271,7 +274,8 @@
 					 */
 					devpoll_update_events(fd, COMM_SELECT_READ, F->read_handler);
 				} else
-					ilog(L_NOTICE, "comm_select: Unhandled read event: fdmask: %x\n", fdmask[fd]);
+                    /* rain - removed extraneous \n */
+					ilog(L_NOTICE, "comm_select: Unhandled read event: fdmask: %x", fdmask[fd]);
 			}
 			if ((dopoll.dp_fds[i].revents & (POLLWRNORM | POLLOUT | POLLHUP | POLLERR)) && (dopoll.dp_fds[i].events & (POLLWRNORM|POLLOUT))) 
 			{
@@ -283,12 +287,14 @@
 					devpoll_update_events(fd, COMM_SELECT_WRITE, F->write_handler);
 				} 
                 		else 
-		    			ilog(L_NOTICE, "comm_select: Unhandled write event: fdmask: %x\n", fdmask[fd]);
+                                        /* rain - removed extraneous \n */
+		    			ilog(L_NOTICE, "comm_select: Unhandled write event: fdmask: %x", fdmask[fd]);
 		
 			}
 	    		if(dopoll.dp_fds[i].revents & POLLNVAL) 
 	    		{
-				ilog(L_NOTICE, "revents was Invalid for %d\n", fd);
+                                /* rain - removed extraneous \n */
+				ilog(L_NOTICE, "revents was Invalid for %d", fd);
 	    		}
 	    	}	
         	return COMM_OK;
diff -uNrd ircd-hybrid-7.0/src/s_bsd_kqueue.c anynet-3.0/src/s_bsd_kqueue.c
--- ircd-hybrid-7.0/src/s_bsd_kqueue.c	Mon Apr  7 19:51:18 2003
+++ anynet-3.0/src/s_bsd_kqueue.c	Thu Jan 22 12:18:19 2004
@@ -159,7 +159,8 @@
   kq = kqueue();
   if (kq < 0)
     {
-      ilog(L_CRIT, "init_netio: Couldn't open kqueue fd!\n");
+      /* rain - removed extraneous \n */
+      ilog(L_CRIT, "init_netio: Couldn't open kqueue fd!");
       exit(115); /* Whee! */
     }
   kqmax = getdtablesize();
diff -uNrd ircd-hybrid-7.0/src/s_conf.c anynet-3.0/src/s_conf.c
--- ircd-hybrid-7.0/src/s_conf.c	Sun Feb 16 17:06:46 2003
+++ anynet-3.0/src/s_conf.c	Wed Feb  4 13:23:35 2004
@@ -50,6 +50,10 @@
 #include "s_debug.h"
 #include "fileio.h"
 #include "memory.h"
+ 
+/* rain - for extended ISUPPORT */
+#include "hook.h"
+#include "isupport.h"
 
 struct config_server_hide ConfigServerHide;
 
@@ -140,9 +144,19 @@
   if (reply && reply->status == adns_s_ok)
   {
 #ifdef IPV6
-    copy_s_addr(IN_ADDR(aconf->ipnum),
-                reply->rrs.addr->addr.inet6.sin6_addr.s6_addr);
+    /* rain - properly set family */
+    aconf->aftype = reply->rrs.addr->addr.inet6.sin6_family;
+    /* rain - check address type so we can have ipv4 addresses... */
+    if (aconf->aftype == AF_INET6)
+        copy_s_addr(IN_ADDR(aconf->ipnum),
+                    reply->rrs.addr->addr.inet6.sin6_addr.s6_addr);
+    else
+        /* rain - kludge - this doesn't fit in with the nice defines */
+        aconf->ipnum.sins.sin.s_addr =
+            reply->rrs.addr->addr.inet.sin_addr.s_addr;
 #else
+    /* rain - properly set family */
+    aconf->aftype = reply->rrs.addr->addr.inet.sin_family;
     copy_s_addr(IN_ADDR(aconf->ipnum),
                 reply->rrs.addr->addr.inet.sin_addr.s_addr);
 #endif
@@ -494,7 +508,8 @@
       break;
     }
     case BANNED_CLIENT:
-      exit_client(client_p,client_p, &me, "*** Banned ");
+      /* rain - better dump reason */
+      exit_client(client_p,client_p, &me, "You are banned from this server");
       ServerStats->is_ref++;
       break;
 
@@ -558,7 +573,8 @@
 		    {
 		      sendto_one(client_p, ":%s NOTICE %s :*** G-lined", me.name,
 				 client_p->name);
-		      sendto_one(client_p, ":%s NOTICE %s :*** Banned %s",
+			  /* rain - added colon after Banned: for readability */
+		      sendto_one(client_p, ":%s NOTICE %s :*** Banned: %s",
 				 me.name, client_p->name, 
 				 gkill_conf->passwd);
 		      return(BANNED_CLIENT);
@@ -589,7 +605,8 @@
 	{
 	  if (ConfigFileEntry.kline_with_reason)
 	    {
-	      sendto_one(client_p, ":%s NOTICE %s :*** Banned %s",
+		  /* rain - added colon after Banned: for readability */
+	      sendto_one(client_p, ":%s NOTICE %s :*** Banned: %s",
 			 me.name,client_p->name,aconf->passwd);
 	    }
 	  return(BANNED_CLIENT);
@@ -623,6 +640,11 @@
         return(TOO_MANY); /* Already at maximum allowed ip#'s */
       else
         {
+          /*
+           * rain - don't send this message directly to the fd, it'll
+           * break SSL clients
+           */
+           
           sendto_one(client_p,
        ":%s NOTICE %s :*** :I: line is full, but you have an >I: line!",
                      me.name,client_p->name);
@@ -998,9 +1020,8 @@
       }
       else
       {
-	send(client_p->localClient->fd,
-	     "NOTICE FLINE :I: line is full, but you have an >I: line!\n",
-	     56, 0);
+    sendto_one(client_p, 
+	     "NOTICE FLINE :I: line is full, but you have an >I: line!");
 	SetExemptLimits(client_p);
       }
     }
@@ -1316,6 +1337,10 @@
   flush_deleted_I_P();
   check_klines();
   reopen_log(logFileName);
+
+  /* rain - tell extended ISUPPORT code to update config and send changes */
+  hook_call_event("update_isupport", ISUP_PROPAGATE);
+
   return(0);
 }
 
@@ -1396,7 +1421,8 @@
   ConfigFileEntry.glines = NO;
   ConfigFileEntry.use_egd = NO;
   /* don't reset msglocale setting -- we'd overwrite then env string */
-  ConfigFileEntry.gline_time = 12 * 3600;
+/* rain - no longer relevant */
+/*  ConfigFileEntry.gline_time = 12 * 3600; */
   ConfigFileEntry.idletime = 0;
   ConfigFileEntry.dots_in_ident = 0;
   ConfigFileEntry.maximum_links = MAXIMUM_LINKS_DEFAULT;
@@ -1412,7 +1438,8 @@
    *        NOTE: I apologise for the hard-coded value of "1" (BF/128).
    *              This should be moved into a find_cipher() routine.
    */
-  ConfigFileEntry.default_cipher_preference = &CipherTable[1];
+  /* rain - BF/128 has been moved to 3, fixing */
+  ConfigFileEntry.default_cipher_preference = &CipherTable[3];
 #endif
 #ifdef HAVE_LIBZ
   ConfigFileEntry.compression_level = 0;
diff -uNrd ircd-hybrid-7.0/src/s_debug.c anynet-3.0/src/s_debug.c
--- ircd-hybrid-7.0/src/s_debug.c	Fri May  2 00:37:35 2003
+++ anynet-3.0/src/s_debug.c	Mon Feb  2 02:48:58 2004
@@ -121,8 +121,9 @@
     rup = 1;
 
 
+  /* rain - fix time formats -- add 02d padding */
   sendto_one(source_p,
-             ":%s %d %s R :CPU Secs %d:%d User %d:%d System %d:%d",
+             ":%s %d %s R :CPU Secs %d:%02d User %d:%02d System %d:%02d",
              me.name, RPL_STATSDEBUG, source_p->name, (int)(secs/60), (int)(secs%60),
              (int)(rus.ru_utime.tv_sec/60), (int)(rus.ru_utime.tv_sec%60),
              (int)(rus.ru_stime.tv_sec/60), (int)(rus.ru_stime.tv_sec%60));
@@ -412,8 +413,9 @@
 	     (int)total_channel_memory,
              (int)conf_memory);
 
+  /* rain - removed cast */
   count_local_client_memory( &local_client_count,
-			     (int *)&local_client_memory_used );
+			     &local_client_memory_used );
   total_memory += local_client_memory_used;
   sendto_one(source_p, ":%s %d %s z :Local client Memory in use: %d(%d)",
              me.name, RPL_STATSDEBUG, source_p->name,
@@ -421,21 +423,24 @@
              (int)local_client_memory_used);
 
 
+  /* rain - removed cast */
   count_remote_client_memory( &remote_client_count,
-			      (int *)&remote_client_memory_used);
+			      &remote_client_memory_used);
   total_memory += remote_client_memory_used;
   sendto_one(source_p, ":%s %d %s z :Remote client Memory in use: %d(%d)",
              me.name, RPL_STATSDEBUG, source_p->name,
 	     remote_client_count,
              (int)remote_client_memory_used);
 
-  count_user_memory( &user_count, (int *)&user_memory_used );
+  /* rain - removed cast */
+  count_user_memory( &user_count, &user_memory_used );
   total_memory += user_memory_used;
   sendto_one(source_p, ":%s %d %s z :User Memory in use: %d(%d)",
              me.name, RPL_STATSDEBUG, source_p->name,
 	     user_count, (int)user_memory_used);
 
-  count_links_memory( &links_count, (int *)&links_memory_used );
+  /* rain - removed cast */
+  count_links_memory( &links_count, &links_memory_used );
   total_memory += links_memory_used;
   sendto_one(source_p, ":%s %d %s z :Links Memory in use: %d(%d)",
              me.name, RPL_STATSDEBUG, source_p->name,
diff -uNrd ircd-hybrid-7.0/src/s_gline.c anynet-3.0/src/s_gline.c
--- ircd-hybrid-7.0/src/s_gline.c	Wed Sep  4 22:48:42 2002
+++ anynet-3.0/src/s_gline.c	Sun Feb  1 16:13:22 2004
@@ -53,7 +53,9 @@
 dlink_list glines;
 
 static void expire_glines(void);
+#if 0 /* rain - pending glines no longer exist */
 static void expire_pending_glines(void);
+#endif
 
 /* add_gline
  *
@@ -150,7 +152,9 @@
 cleanup_glines()
 {
   expire_glines();
+#if 0 /* rain - no more pending gline support */
   expire_pending_glines();
+#endif
 }
 
 /*
@@ -173,6 +177,10 @@
   {
     kill_ptr = gline_node->data;
 
+    /* rain - non-expiring G: line */
+    if (kill_ptr->hold == 0)
+      continue;
+
     if(kill_ptr->hold <= CurrentTime)
     {
       free_conf(kill_ptr);
@@ -182,6 +190,7 @@
   }
 }
 
+#if 0 /* rain - pending glines no longer exist */
 /*
  * expire_pending_glines
  * 
@@ -215,3 +224,4 @@
     }
   }
 }
+#endif
diff -uNrd ircd-hybrid-7.0/src/s_log.c anynet-3.0/src/s_log.c
--- ircd-hybrid-7.0/src/s_log.c	Sat Feb 15 11:32:46 2003
+++ anynet-3.0/src/s_log.c	Thu Jan 22 12:18:53 2004
@@ -211,7 +211,8 @@
   if (IsPerson(source_p))
     {
 
-      ilog(L_INFO, "%s (%3ld:%02ld:%02ld): %s!%s@%s %ld/%ld\n",
+      /* rain - removed extraneous \n */
+      ilog(L_INFO, "%s (%3ld:%02ld:%02ld): %s!%s@%s %ld/%ld",
 	  myctime(source_p->firsttime),
 	  (signed long) on_for / 3600,
 	  (signed long) (on_for % 3600)/60,
diff -uNrd ircd-hybrid-7.0/src/s_misc.c anynet-3.0/src/s_misc.c
--- ircd-hybrid-7.0/src/s_misc.c	Fri May 24 19:34:51 2002
+++ anynet-3.0/src/s_misc.c	Mon Feb  2 10:04:35 2004
@@ -97,7 +97,8 @@
   gm = &gmbuf; 
   lt = localtime(&lclock);
   
-  ircsprintf(buf, "%d/%d/%d %02d.%02d",
+  /* rain - switched format to an ISO8601 date */
+  ircsprintf(buf, "%04d-%02d-%02d %02d.%02d",
              lt->tm_year + 1900, lt->tm_mon + 1, lt->tm_mday,
              lt->tm_hour, lt->tm_min);
   
diff -uNrd ircd-hybrid-7.0/src/s_serv.c anynet-3.0/src/s_serv.c
--- ircd-hybrid-7.0/src/s_serv.c	Sat May 31 03:30:34 2003
+++ anynet-3.0/src/s_serv.c	Wed Feb  4 13:13:39 2004
@@ -111,28 +111,40 @@
 struct EncCapability CipherTable[] =
 {
 #ifdef HAVE_EVP_BF_CFB
-  { "BF/168",     CAP_ENC_BF_168,     24, CIPHER_BF     },
-  { "BF/128",     CAP_ENC_BF_128,     16, CIPHER_BF     },
+/* rain - add BF/256 and BF/192, fix BF/168's len */
+  { "BF/256",     CAP_ENC_BF_256,     32, CIPHER_BF      },
+  { "BF/192",     CAP_ENC_BF_192,     24, CIPHER_BF      },
+  { "BF/168",     CAP_ENC_BF_168,     21, CIPHER_BF      },
+  { "BF/128",     CAP_ENC_BF_128,     16, CIPHER_BF      },
 #endif
 #ifdef HAVE_EVP_CAST5_CFB
-  { "CAST/128",   CAP_ENC_CAST_128,   16, CIPHER_CAST   },
+  { "CAST/128",   CAP_ENC_CAST_128,   16, CIPHER_CAST    },
 #endif
 #ifdef HAVE_EVP_IDEA_CFB
-  { "IDEA/128",   CAP_ENC_IDEA_128,   16, CIPHER_IDEA   },
+  { "IDEA/128",   CAP_ENC_IDEA_128,   16, CIPHER_IDEA    },
 #endif
 #ifdef HAVE_EVP_RC5_32_12_16_CFB
-  { "RC5.16/128", CAP_ENC_RC5_16_128, 16, CIPHER_RC5_16 },
-  { "RC5.12/128", CAP_ENC_RC5_12_128, 16, CIPHER_RC5_12 },
-  { "RC5.8/128",  CAP_ENC_RC5_8_128,  16, CIPHER_RC5_8  },
+  { "RC5.16/128", CAP_ENC_RC5_16_128, 16, CIPHER_RC5_16  },
+  { "RC5.12/128", CAP_ENC_RC5_12_128, 16, CIPHER_RC5_12  },
+  { "RC5.8/128",  CAP_ENC_RC5_8_128,  16, CIPHER_RC5_8   },
 #endif
 #ifdef HAVE_EVP_DES_EDE3_CFB
-  { "3DES/168",   CAP_ENC_3DES_168,   24, CIPHER_3DES   },
+  { "3DES/168",   CAP_ENC_3DES_168,   24, CIPHER_3DES    },
 #endif
 #ifdef HAVE_EVP_DES_CFB
-  { "DES/56",     CAP_ENC_DES_56,      8, CIPHER_DES    },
+  { "DES/56",     CAP_ENC_DES_56,      8, CIPHER_DES     },
 #endif
-
-  { 0,            0,                   0, 0             }
+/* rain - add AES/128, AES/192, and AES/256 */
+#ifdef HAVE_EVP_AES_128_CFB
+  { "AES/128",    CAP_ENC_AES_128,     8, CIPHER_AES_128 },
+#endif
+#ifdef HAVE_EVP_AES_192_CFB
+  { "AES/192",    CAP_ENC_AES_192,    24, CIPHER_AES_192 },
+#endif
+#ifdef HAVE_EVP_AES_256_CFB
+  { "AES/256",    CAP_ENC_AES_256,    32, CIPHER_AES_256 },
+#endif
+  { 0,            0,                   0, 0              }
 };
 #endif
 
@@ -1179,6 +1191,8 @@
       uplink = client_p;
     }
 
+  /* rain - added burst hook */
+  hook_call_event("burst", client_p);
   server_burst(client_p);
 
   return 0;
@@ -1990,7 +2004,12 @@
       return 0;
 
     /* log */
-    inetntop(DEF_FAM, &IN_ADDR(aconf->ipnum), buf, HOSTIPLEN);
+    /*
+     * rain - switched inetntop call to use aconf->aftype instead of
+     * DEF_FAM, so that we get a proper address to log with.
+     */
+     
+    inetntop(aconf->aftype, &IN_ADDR(aconf->ipnum), buf, HOSTIPLEN);
     ilog(L_NOTICE, "Connect to %s[%s] @%s", aconf->user, aconf->host,
          buf);
 
diff -uNrd ircd-hybrid-7.0/src/s_user.c anynet-3.0/src/s_user.c
--- ircd-hybrid-7.0/src/s_user.c	Thu May 29 00:58:03 2003
+++ anynet-3.0/src/s_user.c	Mon Feb  2 02:54:10 2004
@@ -52,6 +52,7 @@
 #include "md5.h"
 #include "memory.h"
 #include "packet.h"
+#include "isupport.h" /* rain - for new ISUPPORT code */
 
 static int valid_hostname(const char* hostname);
 static int valid_username(const char* username);
@@ -73,6 +74,9 @@
 
 static struct flag_item user_modes[] =
 {
+  /* rain - added FLAGS_SERVICE and FLAGS_SSL */
+  {FLAGS_SERVICE, 'N' },
+  {FLAGS_SSL,   'S'},
   {FLAGS_ADMIN, 'a'},
   {FLAGS_BOTS,  'b'},
   {FLAGS_CCONN, 'c'},
@@ -116,12 +120,12 @@
   0,            /* K */
   0,            /* L */
   0,            /* M */
-  0,            /* N */
+  FLAGS_SERVICE,/* N */ /* rain */
   0,            /* O */
   0,            /* P */
   0,            /* Q */
   0,            /* R */
-  0,            /* S */
+  FLAGS_SSL,    /* S */ /* rain */
   0,            /* T */
   0,            /* U */
   0,            /* V */
@@ -238,6 +242,7 @@
 void
 show_isupport(struct Client *source_p) 
 {
+#if 0
   char isupportbuffer[512];
 
   ircsprintf(isupportbuffer, FEATURES, FEATURESVALUES);
@@ -249,6 +254,10 @@
              isupportbuffer);
 
   return;
+#else
+  /* rain - new, extended ISUPPORT code */
+  isupport_send(source_p);
+#endif
 }
 
 
@@ -439,21 +448,28 @@
 
   inetntop(source_p->localClient->aftype, &IN_ADDR(source_p->localClient->ip), 
   				ipaddr, HOSTIPLEN);
+  /* rain - show the port in the connect message */
   sendto_realops_flags(FLAGS_CCONN, L_ALL,
-		       "Client connecting: %s (%s@%s) [%s] {%s} [%s]",
+		       "Client connecting: %s (%s@%s) [%s] {%s} [%s] {%d}",
 		       nick, source_p->username, source_p->host,
 #ifdef HIDE_SPOOF_IPS
                        IsIPSpoof(client_p) ? "255.255.255.255" : ipaddr,
 #else
 		       ipaddr,
 #endif
-		       get_client_class(source_p), source_p->info);
+		       get_client_class(source_p), source_p->info,
+		       source_p->localClient->listener->port);
 
   /* If they have died in send_* don't do anything. */
   if (IsDead(source_p))
     return CLIENT_EXITED;
   
+  /* rain - initial modes are set here */
   source_p->umodes |= FLAGS_INVISIBLE;
+#ifdef SSL_CLIENT_SUPPORT
+  if (source_p->localClient->ssl_state == SSLC_STATE_CONNECTED)
+    source_p->umodes |= FLAGS_SSL;
+#endif
 
   Count.invisi++;
 
@@ -998,6 +1014,14 @@
           what = MODE_DEL;
           break;        
 
+        /* rain - support for +N (service) and +S (secure) */
+        case 'N':
+          if (!IsServer(client_p))
+            badflag = YES;
+          break;
+        case 'S':
+          break;
+
         case 'o' :
           if(what == MODE_ADD)
             {
@@ -1048,8 +1072,10 @@
         default :
           if( (flag = user_modes_from_c_to_bitmask[(unsigned char)*m]))
             {
-              if (MyConnect(source_p) && !IsOper(source_p) &&
-                 (ConfigFileEntry.oper_only_umodes & flag))
+              if ((MyConnect(source_p) && !IsOper(source_p) &&
+                 (ConfigFileEntry.oper_only_umodes & flag)) ||
+                 /* rain - make sure clients can never set +N */
+                 (!IsServer(client_p) && *m == 'N'))
                 {
                   badflag = YES;
                 }
@@ -1227,6 +1253,12 @@
 	     me.name, ircd_version);
   
   show_isupport(source_p);
+#ifdef SSL_CLIENT_SUPPORT
+  /* rain - send SSL clients some cipher info */
+  if (source_p->localClient->ssl_state == SSLC_STATE_CONNECTED)
+    sendto_one(source_p, "NOTICE %s :Connected to %s with cipher %s",
+      source_p->name, me.name, SSLC_cipherinfo(source_p, 0));
+#endif
   
   show_lusers(source_p);
 
diff -uNrd ircd-hybrid-7.0/src/send.c anynet-3.0/src/send.c
--- ircd-hybrid-7.0/src/send.c	Wed Apr  2 20:29:04 2003
+++ anynet-3.0/src/send.c	Mon Feb  2 02:50:13 2004
@@ -293,7 +293,8 @@
   
   if (linebuf_len(&to->localClient->buf_sendq))
   {
-    while((retlen = linebuf_flush(to->localClient->fd, &to->localClient->buf_sendq)) > 0)
+    /* rain - send flush function the Client struct as well (for SSL clients) */
+    while((retlen = linebuf_flush(to->localClient->fd, &to->localClient->buf_sendq, to)) > 0)
     {
       /* We have some data written .. update counters */
 #ifndef NDEBUG
@@ -1247,7 +1248,8 @@
 
   va_end(args);
 
-  DLINK_FOREACH_SAFE(ptr, ptr_next, oper_list.head)
+  /* rain - allow non-opers to see wallops */
+  DLINK_FOREACH_SAFE(ptr, ptr_next, lclient_list.head)
   {
     client_p = ptr->data;
 
